      subroutine potts_init(lpr) ! Bernd Berg, Jun 3 2005.
C Initializes arrays for Potts Model MC Metropolis calculations.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      include 'lat.par'
      include 'potts.par'
      include 'mc.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension ix(nd)
      ltest=.true.
      ltest=.false.
      if(ltest) stop "potts_init: ltest."
 
      if(lpr) write(iuo,'(" potts_init.f: ")')
C Initialize:
      if(lpr) call rmaset(iuo,iud1,iseed1,iseed2,'nexiste.pa') ! ran-num
      if(.not.lpr) call rmaset(-iuo,iud1,iseed1,iseed2,'nexiste.pa') 
      call ranmar(xr) ! first random number
      acpt=zero                                        ! acceptance rate
      ia_min=mlink
      ia_max=0
      ns=nsfun(nla,nd)
      if(ns.gt.ms) stop "potts_init.f: ns.gt.ms."
      call lat_init(ms,nd,ipf,ipb,nla,ix)           ! lattice
      call potts_act_tab(idel,nqm1)                 ! potts action table
      if(istart.eq.1) call potts_order(ista,iact,nd,ms,izero) ! ordered.
      if(istart.eq.2) call potts_ran(ista,ms,nq) ! random start.
      if(istart.ne.1.and.istart.ne.2) stop "potts_init: istart false."
      call potts_act(ista,ipf,idel,ms,nqm1,nd,iact)       ! potts action
      call potts_wght(wrat,beta,mlink,nd)                ! potts weights
      call razero(ha,izero,mlink)             ! initialize action histogram
C
      if(.not.lpr) return
      write(iuo,'(" Initial randon number: xr =",1F12.6)') xr
      write(iuo,'(" lat.par: nd,nq,nla      =",1I2,1I3,3X,8I4)')
     &                       nd,nq,nla
      write(iuo,'("          ms,mlink,mlink =",3I10)') ms,mlink,mlink
      write(iuo,'(" mc.par:")')
      write(iuo,'(1X,"iuo,iud1,iseed1,iseed2,    beta")')
      write(iuo,'(        2I4,          2I7,     1F11.6)')
     &                      iuo,iud1,iseed1,iseed2,beta
      write(iuo,'(" nequi,nrpt,nmeas,nsw:",I12,I6,I12,I6)') 
     &              nequi,nrpt,nmeas,nsw
      if(istart.eq.1) write(iuo,'(" Ordered start istart =",I9)') istart
      if(istart.eq.2) write(iuo,'(" Random start istart =",I9)') istart
      write(iuo,'(" Initial action iact =",I9)') iact
      return
      end
