      program pibootstrp ! Bernd Berg Sep 09 2008.
c pi estimate with bootstrp and heapsort.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      parameter(iuo=6,iud=10,miuo=-iuo,iseed1=1,iseed2=1)
      parameter(ndat=10**3,nrpt=1001,nq=1)
      dimension api(nrpt),apib(nrpt),qtl(nq)
c     qtl(1)=-one
      if(2*(nrpt/2).eq.nrpt) stop "pibootstrp: chose nrpt odd."
c
      write(iuo,'(/," ndat,nprt, pi analytical =",2I9,1F10.5,/)') 
     &                ndat,nrpt,pi
      call rmaset(miuo,iud,iseed1,iseed2,'ranmar.d')
      do irpt=1,nrpt
        events=zero
        do idat=1,ndat
          call ranmar(xr)
          call ranmar(yr)
	  if(xr**2+yr**2.lt.one) events=events+one
        end do
        api(irpt)=4*events/ndat
        call write_progress(iud,"irpt,nrpt,api:",irpt,nrpt,api(irpt))
      enddo
      call bootstrp(api,nrpt,apib,nrpt,qtl,nq)
      i025=nint(0.025d00*nrpt)
      i15=nint(0.15d00*nrpt)
      i50=1+nrpt/2
      i85=nint(0.85d00*nrpt)
      i975=nint(0.975d00*nrpt)
      write(iuo,'(" 95% and 70% confidence ranges:",/)') 
      write(iuo,'(6X,"0.025%",7X,"15%",7X,"Median",8X,"85%",8X,"97.5%",/
     &  ,/,5F12.7)') apib(i025),apib(i15),apib(i50),apib(i85),apib(i975)
      write(iuo,'(3X,"at array locations:",/,5I12,/)') 
     &                         i025,i15,i50,i85,i975
      call qdf_gnu(iud,nrpt,apib)
c
      stop
      end

      include '../../Libs/Fortran/bootstrp.f'
      include '../../Libs/Fortran/heapsort.f'
      include '../../Libs/Fortran/qdf_gnu.f'
      include '../../Libs/Fortran/qtiles.f'
      include '../../Libs/Fortran/rmafun.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/write_progress.f'
